package geniusweb.profile.utilityspace;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;

import geniusweb.issuevalue.DiscreteValue;
import geniusweb.profile.utilityspace.DiscreteValueSetUtilities;
import tudelft.utilities.junit.GeneralTests;

public class DiscreteValueSetUtilitiesTest extends GeneralTests<DiscreteValueSetUtilities> {

	private final static DiscreteValue vala = new DiscreteValue("a");
	private final static DiscreteValue vala1 = new DiscreteValue("a");
	private final static DiscreteValue valb = new DiscreteValue("b");

	private final static BigDecimal util = new BigDecimal("0.14");
	private final static BigDecimal util1 = new BigDecimal("0.14");
	private final static BigDecimal utilb = new BigDecimal("0.37");

	private final static DiscreteValueSetUtilities utils, utils1, utilsb, utils1b, utilsc1, utilsc2;

	static {
		Map<DiscreteValue, BigDecimal> valueUtils = new HashMap<>();
		Map<DiscreteValue, BigDecimal> valueUtils1 = new HashMap<>();
		Map<DiscreteValue, BigDecimal> valueUtilsb = new HashMap<>();
		Map<DiscreteValue, BigDecimal> valueUtils1b = new HashMap<>();

		Map<DiscreteValue, BigDecimal> valueUtilsc1 = new HashMap<>();
		Map<DiscreteValue, BigDecimal> valueUtilsc2 = new HashMap<>();

		valueUtils.put(vala, util);
		valueUtils1.put(vala1, util1); // same value and utility
		valueUtilsb.put(valb, utilb); // different value and utility
		valueUtils1b.put(vala, utilb); // same value, different utility.

		valueUtilsc1.put(vala, util1);
		valueUtilsc1.put(valb, utilb);

		valueUtilsc1.put(valb, utilb);
		valueUtilsc1.put(vala1, util1);

		utils = new DiscreteValueSetUtilities(valueUtils);
		utils1 = new DiscreteValueSetUtilities(valueUtils1);
		utilsb = new DiscreteValueSetUtilities(valueUtilsb);
		utils1b = new DiscreteValueSetUtilities(valueUtils1b);

		utilsc1 = new DiscreteValueSetUtilities(valueUtilsc1);
		utilsc2 = new DiscreteValueSetUtilities(valueUtilsc1);
	}

	@Override
	public List<List<DiscreteValueSetUtilities>> getGeneralTestData() {
		return Arrays.asList(Arrays.asList(utils, utils1), Arrays.asList(utilsb), Arrays.asList(utils1b),
				Arrays.asList(utilsc1, utilsc2));
	}

	@Override
	public List<String> getGeneralTestStrings() {
		return Arrays.asList("ValueSetUtilities\\{\"a\"=0.14\\}", "ValueSetUtilities\\{\"b\"=0.37\\}",
				"ValueSetUtilities\\{\"a\"=0.37\\}", "ValueSetUtilities\\{\"a\"=0.14, \"b\"=0.37\\}");
	}

	@Test
	public void smokeTest() {
		Map<DiscreteValue, BigDecimal> valueUtils = new HashMap<>();
		new DiscreteValueSetUtilities(valueUtils);
	}

}
