package geniusweb.profile.utilityspace;

import static org.junit.Assert.assertEquals;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import org.junit.Test;

import geniusweb.issuevalue.NumberValue;
import geniusweb.profile.utilityspace.NumberValueSetUtilities;
import tudelft.utilities.junit.GeneralTests;

public class NumberValueSetUtilTest extends GeneralTests<NumberValueSetUtilities> {

	private static final BigDecimal lowval1 = new BigDecimal("12.5");
	private static final BigDecimal low1util = new BigDecimal("0.5");
	private static final BigDecimal low1utilb = new BigDecimal("0.6");
	private static final BigDecimal highval = new BigDecimal("18.5");
	private static final BigDecimal highvalb = new BigDecimal("18.4");
	private static final BigDecimal highutil = new BigDecimal("0.9");
	private static final NumberValueSetUtilities valueset1 = new NumberValueSetUtilities(lowval1, low1util, highval,
			highutil);
	private static final NumberValueSetUtilities valueset1b = new NumberValueSetUtilities(lowval1, low1util, highval,
			highutil);
	private static final NumberValueSetUtilities valueset2 = new NumberValueSetUtilities(lowval1, low1utilb, highval,
			highutil);
	private static final NumberValueSetUtilities valueset3 = new NumberValueSetUtilities(lowval1, low1util, highvalb,
			highutil);

	@Override
	public List<List<NumberValueSetUtilities>> getGeneralTestData() {
		return Arrays.asList(Arrays.asList(valueset1, valueset1b), Arrays.asList(valueset2), Arrays.asList(valueset3));
	}

	@Override
	public List<String> getGeneralTestStrings() {
		return Arrays.asList("NumberValUtility\\(12.5->0.5,18.5->0.9\\)", "NumberValUtility\\(12.5->0.6,18.5->0.9\\)",
				"NumberValUtility\\(12.5->0.5,18.4->0.9\\)");
	}

	@Test
	public void smoketest() {
		NumberValueSetUtilities utils = valueset1;
	}

	@Test
	public void utilAscentingTest() {
		NumberValueSetUtilities utils = valueset1;
		assertEquals(0, low1util.compareTo(utils.getUtility(new NumberValue(lowval1))));
	}

	@Test
	public void utilDescendingTest() {
		NumberValueSetUtilities utils = new NumberValueSetUtilities(lowval1, highutil, highval, low1util);
		assertEquals(0, highutil.compareTo(utils.getUtility(new NumberValue(lowval1))));
	}

	@Test(expected = IllegalArgumentException.class)
	public void reverserangetest() {
		NumberValueSetUtilities utils = new NumberValueSetUtilities(highval, highutil, lowval1, low1util);
	}

}
